'A reference to the Phidget22.NET.dll must be added to new projects in VB.Net 
'From the "Project" menu select "Add Reference" 
'From the "Add Reference" window select the "Browse" tab 
'Browse to the directory you installed the Phidgets library to 
'The default is "C:\Program Files\Phidgets" 
'Select "Phidget22.NET.dll" and click "OK" 
'To view objects that have been added, select the "View" menu 
'Select "Object Browser" 
'Then expand the Phidget22.NET.dll item 



Imports Phidget22
Imports Phidget22.Events

Public Class Form1
    Dim WithEvents device As Phidget22.Encoder
    Dim open As ExampleUtils.ExampleUtils.CommandLineOpen
    Dim errorBox As ErrorEventBox
    Dim CPR As Integer = -1

    Public Sub New()
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)

        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Public Sub New(ByVal commandLine As String())
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        open.commandLine = commandLine
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ioModeCmb.DataSource = [Enum].GetValues(GetType(EncoderIOMode))
        ioModeCmb.SelectedIndex = -1

        errorBox = New ErrorEventBox(Me)

        device = New Phidget22.Encoder()

        Dim phidgetParameters As ExampleUtils.commandLineData = open.parseCmdLine()

        Try 'set all the values grabbed from command line.  these values have defaults that are set in ExampleUtils.vb, you can check there to see them
            device.Channel = phidgetParameters.Channel 'selects the channel on the device to open
            device.DeviceSerialNumber = phidgetParameters.SerialNumber 'selects the device or hub to open
            device.HubPort = phidgetParameters.HubPort 'selects th eport on the hub to open
            device.IsHubPortDevice = phidgetParameters.isHubPortDevice 'is the device a port on a vint hub?

            If phidgetParameters.isRemote Then 'are we trying to open a remote device?
                device.IsRemote = True
                Net.EnableServerDiscovery(ServerType.Device) 'turn on network scan
                If phidgetParameters.Password <> vbNullString And phidgetParameters.ServerName <> vbNullString Then
                    Net.SetServerPassword(phidgetParameters.ServerName, phidgetParameters.Password)
                End If
            Else
                device.IsLocal = True
            End If

            device.Open() 'open the device specified by the above parameters
        Catch ex As PhidgetException
            errorBox.addMessage("Error opening the device: " + ex.Message)
        End Try
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Application.DoEvents()
        If device.Attached Then
            device.Close()
        End If
    End Sub

    Private Sub device_Attach(ByVal sender As Object, ByVal e As Phidget22.Events.AttachEventArgs) Handles device.Attach
        PhidgetInfoBox1.FillPhidgetInfo(CType(sender, Encoder))

        Dim attachedDevice As Phidget22.Encoder = CType(sender, Phidget22.Encoder)

        If device.DeviceClass = DeviceClass.VINT Then
            Try
                dataIntervalTrk.Unit = "ms"
                dataIntervalTrk.trkText = dataIntervalTrk.minTxt = attachedDevice.MinDataInterval.ToString()
                dataIntervalTrk.Minimum = attachedDevice.MinDataInterval
                dataIntervalTrk.maxTxt = attachedDevice.MaxDataInterval.ToString()
                dataIntervalTrk.Maximum = attachedDevice.MaxDataInterval
                dataIntervalTrk.Value = attachedDevice.DataInterval

                'differing max/min means the interval Is a settable configuration
                If attachedDevice.MaxDataInterval = attachedDevice.MinDataInterval Then
                    dataIntervalTrk.Enabled = False
                End If

                changeTriggerTrk.Unit = "ticks"
                changeTriggerTrk.trkText = changeTriggerTrk.minTxt = attachedDevice.MinPositionChangeTrigger.ToString()
                changeTriggerTrk.Minimum = attachedDevice.MinPositionChangeTrigger
                changeTriggerTrk.Maximum = attachedDevice.MaxPositionChangeTrigger
                changeTriggerTrk.maxTxt = attachedDevice.MaxPositionChangeTrigger.ToString()
                changeTriggerTrk.Value = attachedDevice.PositionChangeTrigger
                changeTriggerTrk.trkText = attachedDevice.PositionChangeTrigger.ToString("F0")

            Catch ex As PhidgetException
                errorBox.addMessage("Error setting data interval or change trigger: " + ex.Message)
            End Try
        Else
            changeTriggerTrk.Hide()
            dataIntervalTrk.Hide()
            iomodePanel.Hide()
        End If

        timeTxt.Clear()
        positionTxt.Clear()
        indexTxt.Clear()
        cumulativePosition.Clear()
        timeTxt.Text = "N/A"
        positionTxt.Text = "N/A"
        indexTxt.Text = "N/A"
        cumulativePosition.Text = "N/A"

        Select Case attachedDevice.DeviceID
            Case DeviceID.PN_1047
                enabledChk.Visible = True
                enabledChk.Checked = True
                attachedDevice.Enabled = True
                dataIntervalTrk.Visible = False
            Case DeviceID.PN_HIN1101
                enabledChk.Visible = True
                enabledChk.Checked = True
                attachedDevice.Enabled = True
                dataIntervalTrk.Visible = False
            Case DeviceID.PN_ENC1000
                For Each eio As EncoderIOMode In [Enum].GetValues(GetType(EncoderIOMode))
                    ioModeCmb.Items.Add(eio)
                Next
                ioModeCmb.SelectedIndex = 0
            Case DeviceID.PN_DCC1000
                ioModeCmb.SelectedIndex = 0
        End Select

        settingsBox.Visible = True
        outputBox.Visible = True
    End Sub

    Private Sub device_Detach(ByVal sender As Object, ByVal e As Phidget22.Events.DetachEventArgs) Handles device.Detach
        PhidgetInfoBox1.Clear()

        settingsBox.Visible = False
        outputBox.Visible = False

        ioModeLbl.Visible = False
        ioModeCmb.Visible = False
        enabledChk.Visible = False
        dataIntervalTrk.Enabled = False
    End Sub

    Private Sub device_Error(ByVal sender As Object, ByVal e As Phidget22.Events.ErrorEventArgs) Handles device.Error
        errorBox.addMessage(e.Description)
    End Sub

    Private Sub device_EncoderChange(ByVal sender As Object, ByVal e As Phidget22.Events.EncoderPositionChangeEventArgs) Handles device.PositionChange
        Try
            positionTxt.Text = e.PositionChange.ToString + " ticks"
            timeTxt.Text = e.TimeChange.ToString + " ms"

            If (e.IndexTriggered) Then
                indexTxt.Text = device.IndexPosition.ToString + " ticks"
            End If
            cumulativePosition.Text = device.Position.ToString + " ticks"

            If (CPR <> -1) Then
                rpmTxt.Text = (e.PositionChange * 60000 / e.TimeChange / CPR).ToString("n1") + " RPM"
            End If
        Catch ex As Exception
            errorBox.addMessage("Error reading position: " + ex.Message)
        End Try
    End Sub


    Private Sub ioModeCmb_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ioModeCmb.SelectedIndexChanged
        If (CType(sender, ComboBox).SelectedItem Is Nothing Or device Is Nothing) Then
            Return
        End If

        Try
            device.IOMode = CType([Enum].Parse(GetType(EncoderIOMode), ioModeCmb.SelectedValue.ToString()), EncoderIOMode)
        Catch ex As Exception
            errorBox.addMessage("Error setting IO mode: " + ex.Message)
        End Try
    End Sub


    Private Sub dataIntervalTrk_Scroll(sender As Object, e As EventArgs) Handles dataIntervalTrk.LogScroll
        If (MouseButtons = MouseButtons.Left) Then
            Try
                device.DataInterval = CType(dataIntervalTrk.Value, Integer)
            Catch ex As Exception
                errorBox.addMessage("Error setting data interval: " + ex.Message)
            End Try
        End If
    End Sub

    Private Sub dataIntervalTrk_LogMouseUp(sender As Object, e As EventArgs) Handles dataIntervalTrk.LogMouseUp
        Try
            device.DataInterval = CType(dataIntervalTrk.Value, Integer)
        Catch ex As Exception
            errorBox.addMessage("Error setting data interval: " + ex.Message)
        End Try
    End Sub

    Private Sub changeTriggertrk_Scroll(sender As Object, e As EventArgs) Handles changeTriggerTrk.LogScroll
        If (MouseButtons = MouseButtons.Left) Then
            Try
                device.PositionChangeTrigger = CType(changeTriggerTrk.Value, Integer)
            Catch ex As Exception
                errorBox.addMessage("Error setting data interval: " + ex.Message)
            End Try
        End If
    End Sub

    Private Sub changeTriggerTrk_LogMouseUp(sender As Object, e As EventArgs) Handles changeTriggerTrk.LogMouseUp
        Try
            device.PositionChangeTrigger = CType(changeTriggerTrk.Value, Integer)
        Catch ex As Exception
            errorBox.addMessage("Error setting data interval: " + ex.Message)
        End Try
    End Sub

    Private Sub enabledChk_CheckedChanged(sender As Object, e As EventArgs) Handles enabledChk.CheckedChanged
        Try
            device.Enabled = enabledChk.Checked
        Catch ex As Exception
            errorBox.addMessage("error setting enabled: " + ex.Message)
        End Try
    End Sub

    Private Sub CPRSetBtn_Click(sender As Object, e As EventArgs) Handles CPRSetBtn.Click
        CPR = Int32.Parse(cprTxt.Text)
    End Sub

    Private Sub cprTxt_KeyDown(sender As Object, e As KeyEventArgs) Handles cprTxt.KeyDown
        If (e.KeyCode = Keys.Enter) Then
            Try
                If (cprTxt.Text <> "" And cprTxt.Text <> "0") Then
                    CPR = Int32.Parse(cprTxt.Text)
                Else
                    CPR = -1
                    rpmTxt.Text = "N/A"
                    cprTxt.Text = ""
                End If
            Catch ex As Exception
                errorBox.addMessage("Invalid CPR value.")
                cprTxt.Text = ""
            End Try
            e.SuppressKeyPress = True
        End If
    End Sub

    Private Sub rstBtn_Click(sender As Object, e As EventArgs) Handles rstBtn.Click
        Try
            device.Position = 0
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting position: " + ex.Message)
        End Try
    End Sub
End Class



